/**
 */
package de.upb.swt.swtpra2017.swtinterface.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import de.upb.swt.swtpra2017.swtinterface.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see de.upb.swt.swtpra2017.swtinterface.Tsuro_InterfacePackage
 * @generated
 */
public class Tsuro_InterfaceSwitch {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static Tsuro_InterfacePackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Tsuro_InterfaceSwitch() {
		if (modelPackage == null) {
			modelPackage = Tsuro_InterfacePackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case Tsuro_InterfacePackage.TURN_NOTIFICATION: {
				TurnNotification turnNotification = (TurnNotification)theEObject;
				Object result = caseTurnNotification(turnNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.KICK_NOTIFICATION: {
				KickNotification kickNotification = (KickNotification)theEObject;
				Object result = caseKickNotification(kickNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_STATE_NOTIFICATION: {
				GameStateNotification gameStateNotification = (GameStateNotification)theEObject;
				Object result = caseGameStateNotification(gameStateNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.POSITION: {
				Position position = (Position)theEObject;
				Object result = casePosition(position);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.TILE: {
				Tile tile = (Tile)theEObject;
				Object result = caseTile(tile);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.PLAYER: {
				Player player = (Player)theEObject;
				Object result = casePlayer(player);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.SET_TOKEN_CMD: {
				SetTokenCmd setTokenCmd = (SetTokenCmd)theEObject;
				Object result = caseSetTokenCmd(setTokenCmd);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.TOKEN: {
				Token token = (Token)theEObject;
				Object result = caseToken(token);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.FINISHED_NOTIFICATION: {
				FinishedNotification finishedNotification = (FinishedNotification)theEObject;
				Object result = caseFinishedNotification(finishedNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.CONFIGURATION: {
				Configuration configuration = (Configuration)theEObject;
				Object result = caseConfiguration(configuration);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME: {
				Game game = (Game)theEObject;
				Object result = caseGame(game);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.SET_TILE_CMD: {
				SetTileCmd setTileCmd = (SetTileCmd)theEObject;
				Object result = caseSetTileCmd(setTileCmd);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_LIST_REQUEST: {
				GameListRequest gameListRequest = (GameListRequest)theEObject;
				Object result = caseGameListRequest(gameListRequest);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_LIST_RESPONSE: {
				GameListResponse gameListResponse = (GameListResponse)theEObject;
				Object result = caseGameListResponse(gameListResponse);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_JOIN_REQUEST: {
				GameJoinRequest gameJoinRequest = (GameJoinRequest)theEObject;
				Object result = caseGameJoinRequest(gameJoinRequest);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_START_NOTIFICATION: {
				GameStartNotification gameStartNotification = (GameStartNotification)theEObject;
				Object result = caseGameStartNotification(gameStartNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_PAUSE_NOTIFICATION: {
				GamePauseNotification gamePauseNotification = (GamePauseNotification)theEObject;
				Object result = caseGamePauseNotification(gamePauseNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.GAME_CONTINUE_NOTIFICATION: {
				GameContinueNotification gameContinueNotification = (GameContinueNotification)theEObject;
				Object result = caseGameContinueNotification(gameContinueNotification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.PLACEMENT: {
				Placement placement = (Placement)theEObject;
				Object result = casePlacement(placement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case Tsuro_InterfacePackage.PROCESSING_REQUEST_REPLY: {
				ProcessingRequestReply processingRequestReply = (ProcessingRequestReply)theEObject;
				Object result = caseProcessingRequestReply(processingRequestReply);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Turn Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Turn Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTurnNotification(TurnNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Kick Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Kick Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseKickNotification(KickNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game State Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game State Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGameStateNotification(GameStateNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Position</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Position</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePosition(Position object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Tile</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Tile</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTile(Tile object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Player</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Player</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePlayer(Player object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Token Cmd</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Token Cmd</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSetTokenCmd(SetTokenCmd object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Token</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Token</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseToken(Token object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Finished Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Finished Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFinishedNotification(FinishedNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Configuration</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Configuration</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConfiguration(Configuration object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGame(Game object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Tile Cmd</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Tile Cmd</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSetTileCmd(SetTileCmd object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game List Request</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game List Request</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGameListRequest(GameListRequest object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game List Response</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game List Response</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGameListResponse(GameListResponse object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game Join Request</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game Join Request</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGameJoinRequest(GameJoinRequest object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game Start Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game Start Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGameStartNotification(GameStartNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game Pause Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game Pause Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGamePauseNotification(GamePauseNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Game Continue Notification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Game Continue Notification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGameContinueNotification(GameContinueNotification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Placement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Placement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePlacement(Placement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Processing Request Reply</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Processing Request Reply</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessingRequestReply(ProcessingRequestReply object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} //Tsuro_InterfaceSwitch
